/* dynamictable.h
 *
 * Copyright (C) 2001 Michael McTernan,
 *   Michael.McTernan.2001@cs.bris.ac.uk
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */

#ifndef DYNAMIC_TABLE_HEADER 
#define DYNAMIC_TABLE_HEADER 


struct exec_action {
//  int (*func)();
  int (*func)(int argC,const char **argV);
};


struct cgi_action {
  const char *exec_string;
};

struct page_action {
  const char *data;
  int         length; 
};


typedef enum {
  exec_action_code=0,
  cgi_action_code,
  page_action_code 
} action_code_t;


struct table_entry {

  const char    *url;   /**< URL for which this entry applies */
  action_code_t  type;  /**< Identifies which union entry is used */

  union {
    struct page_action page;  /**< Specifics for a page rendering action */
    struct exec_action exec;  /**< Specifics for an exec action */
    struct cgi_action  cgi;   /**< Specifics for a cgi action */
  } u;

};

extern const struct table_entry content_table[];

#endif
