/* utils.h
 *
 * Copyright (C) 2001 Michael McTernan,
 *   Michael.McTernan.2001@cs.bris.ac.uk
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */

#ifndef UTILS_HEADER 
#define UTILS_HEADER

#include <stdio.h>
#include <errno.h>
#include <stdlib.h>

#define writeString(a,b)   write((a),(b),strlen(b))  

#ifdef __func__

#define critical(a)  if(!(a)) { \
                       fprintf(stderr,"%s:%d: %s: Critical '%s' failed.\n",__FILE__,__LINE__,__func__,#a); \
                       abort(); \
                     }

#define warning(a)  if(!(a)) { \
                       fprintf(stderr,"%s:%d: %s: Warning: '%s' failed.\n",__FILE__,__LINE__,__func__,#a); \
                     }
#else

#define critical(a)  if(!(a)) { \
                       fprintf(stderr,"%s:%d: Critical '%s' failed.\n",__FILE__,__LINE__,#a); \
                       abort(); \
                     }
 
#define warning(a)  if(!(a)) { \
                       fprintf(stderr,"%s:%d: Warning: '%s' failed.\n",__FILE__,__LINE__,#a); \
                     }

#endif 

#endif
