#!/bin/sh

foot () {
  echo "<ul>"
  echo "<li><a href=\"/cgi-bin/ipchains.c\">Firewall Rules</a>"
  echo "<li><a href=\"/\">Main menu</a>"
  echo "</ul>"
}

echo "<h2>Add Firewall Rule</h2>"

if [ -z "$QUERY_STRING" ]; then
  echo "<p>Malformed request</p>"
  exit
fi

parse() {
  VAL=`echo $QUERY_STRING | sed "s/.*$PARAM=\([^&]*\)\(&.*\|$\)/\1/"`
}

PARAM=position; parse; POSITION=$VAL;
PARAM=chain; parse; CHAIN=$VAL;
PARAM=target; parse; TARGET=$VAL;
PARAM=proto; parse; PROTO=$VAL;
PARAM=sip; parse; SIP=$VAL;
PARAM=smsk; parse; SMSK=$VAL;
PARAM=sport; parse; SPORT=$VAL;
PARAM=dip; parse; DIP=$VAL;
PARAM=dmsk; parse; DMSK=$VAL;
PARAM=dport; parse; DPORT=$VAL;

if [ "$POSITION" = "top" ]; then
  CMD="ipchains -I $CHAIN 1"
fi

if [ "$POSITION" = "bottom" ]; then
  CMD="ipchains -A $CHAIN"
fi

if [ "$PROTO" = "icmp" ] ; then
  if [ -n "$DPORT$SPORT" ]; then
    echo "<p>When specifying ICMP as a protocol, you cannot specify ports.</p>"
    foot
    exit
  fi
fi

CMD="$CMD -p $PROTO"

if [ -n "$SIP" ]; then
  CMD="$CMD -s $SIP"
  if [ -n "$SMSK" ]; then
    CMD="$CMD/$SMSK"
  fi
fi

if [ -n "$SPORT" ]; then
  CMD="$CMD --sport $SPORT"
fi

if [ -n "$DIP" ]; then
  CMD="$CMD -d $DIP"
  if [ -n "$DMSK" ]; then
    CMD="$CMD/$DMSK"
  fi
fi

if [ -n "$DPORT" ]; then
  CMD="$CMD --dport $DPORT"
fi

CMD="$CMD -j $TARGET"

echo "$CMD" >> /etc/rc.d/rc.firewall
$CMD

echo "<p>A rule has been added to the $POSITION of the $CHAIN table.</p>"

touch /etc/coyote/coyote.conf.dirty 

foot

