#!/bin/sh

. /etc/coyote/coyote.conf

echo "<h2>Sane Firewall Ruleset</h2>"

sed "s/^[^#].*pchains -[FPAD].*$//" /etc/rc.d/rc.firewall > /tmp/rc.firewall
cp /tmp/rc.firewall /etc/rc.d/rc.firewall
chmod 0755 /etc/rc.d/rc.firewall
rm -f /tmp/rc.firewall

(
echo ipchains -F input 
echo ipchains -F output
echo ipchains -F forward
echo "[ -n \"\$DNS1\" ] && ipchains -A input -p udp -s \$DNS1 53 -j ACCEPT"
echo "[ -n \"\$DNS2\" ] && ipchains -A input -p udp -s \$DNS2 53 -j ACCEPT"
echo ipchains -A input -p tcp --dport 22 -j ACCEPT
echo ipchains -A input -i lo -j ACCEPT
echo ipchains -A input -p tcp --dport 0:1023 -i $IF_INET -j DENY
echo ipchains -A input -p udp --dport 0:1023 -i $IF_INET -j DENY
echo ipchains -A input -p tcp --dport 2049 -i $IF_INET -y -j DENY
echo ipchains -A input -p udp --dport 2049 -i $IF_INET -j DENY
echo ipchains -A input -p tcp --dport 6000:6009 -y -j DENY
echo ipchains -A input -p tcp --dport 7100 -y -j DENY
echo ipchains -A input -p tcp --dport 888 -i $IF_INET -j DENY
echo ipchains -P input ACCEPT
echo ipchains -P output ACCEPT
echo ipchains -A forward -j MASQ -s \$LOCAL_NETWORK/\$LOCAL_NETMASK -d 0.0.0.0/0
echo ipchains -P forward DENY
) >> /etc/rc.d/rc.firewall

. /etc/rc.d/rc.firewall   

echo "<p>A sane firewall ruleset has been established</p>"
echo "<ul><li><a href=\"ipchains.c\">View ruleset</a><br><br>"
echo "<li><a href=\"/\">Main menu</a></ul>"

touch /etc/coyote/coyote.conf.dirty
