#!/bin/sh

echo "<h2>Port Forwarding</h2>"

if [ -z "$QUERY_STRING" ]; then
  echo "<p>Malformed request</p>"
  exit
fi

PORT=`echo $QUERY_STRING | sed "s/.*port=\([0-9]*\)\(&.*\|$\)/\1/"`
DIP=`echo $QUERY_STRING | sed "s/.*IP=\([0-9]*\.[0-9]*\.[0-9]*\.[0-9]*\)\(&.*\|$\)/\1/"`
PROTO=`echo $QUERY_STRING | sed "s/.*proto=\(tcp\|ip\)\(&.*\|$\)/\1/"`

echo "ipmasqadm autofw -A -r $PROTO $PORT $PORT -h $DIP" >> /etc/rc.d/rc.portfwd

ipmasqadm autofw -F
. /etc/rc.d/rc.portfwd

ipchains -I input 1 -p $PROTO --dport $PORT -j ACCEPT
echo "ipchains -I input 1 -p $PROTO --dport $PORT -j ACCEPT" >> /etc/rc.d/rc.firewall

echo "<p>$PROTO packets arriving on port $PORT will now be"
echo "forwarded to $DIP.  A rule has also been added to the"
echo "firewall ruleset to ensure that packets arriving on port $PORT"
echo "will be accepted.</p>"

echo "<ul>"
echo "<li><a href=\"/cgi-bin/ipfwd-list.cgi\">Port forwarding</a>"
echo "<li><a href=\"/cgi-bin/ipchains.c\">Firewall ruleset</a><br><br>"
echo "<li><a href=\"/\">Main menu</a>"
echo "</ul>"

touch /etc/coyote/coyote.conf.dirty
