#!/bin/sh

. /etc/coyote/coyote.conf

getval () {
  VAL=`echo $QUERY_STRING | sed "s/.*$PARAM=\([^&]*\)\(&.*\|$\)/\1/"`
  for EXP in "y/+/ /" ":s;/%26/s//\&/;t s" ":s;/%3D/s//\=/;t s" \
             ":s;/%2F/s//\//;t s" ":s;/%3A/s//\:/;t s" ; do
    VAL=`echo $VAL | sed -e "$EXP"` 
  done 
}

getcheck () {
  PARAM="$PARAM1"
  getval
  if [ "$VAL" = "on" ]; then 
    VAL="YES"
  else
    VAL="NO"
  fi
}

getcheckval () {
  PARAM="$PARAM1"
  getval
  if [ "$VAL" = "on" ]; then
    PARAM="$PARAM2"
    getval
    VAL="$VAL"
  else
    VAL="NO"
  fi
}

echo "<h2>Changed ISP Parameters</h2>"

if [ -z "$QUERY_STRING" ]; then
  echo "<p>Malformed request</p><ul><li><a href=\"/\">Main menu</a></ul>"
  exit
fi

PARAM=isp; getval; ISP="$VAL"

(
  echo ". /etc/coyote/coyote.conf"
  echo "rm -f /etc/coyote/coyote.conf" 

  for PAIR in "phonenum,PPP_PHONENUM" "user,PPP_USERNAME" "pass,PPP_PASSWORD" \
              "isp,PPP_ISP" ; do
    PARAM=`echo $PAIR | sed "s/\([^,]*\).*/\1/"`
    getval
    echo "`echo $PAIR | sed "s/[^,]*,\(.*\)/\1/"`=\"$VAL\""
  done

  PARAM1="statip";PARAM2="staticipad";getcheckval;echo "PPP_STATICIP=\"$VAL\""

  PARAM1="chatlogin";getcheck;echo "PPP_CHATLOGIN=\"$VAL\""
  PARAM1="bsdcp";getcheck;echo "PPP_BSDCOMP=\"$VAL\""
  PARAM1="defcp";getcheck;echo "PPP_DEFLATE=\"$VAL\""

 echo "(" 
 cat /etc/coyote/coyote.conf | sed "s/\([^=]*\).*/echo \"\1=\\\\\"$\1\\\\\"\"/" 
 echo ") > /etc/coyote/coyote.conf" 

 echo "("
 echo "echo \"PPP_PHONENUM=\\\"\$PPP_PHONENUM\\\"\""
 echo "echo \"PPP_USERNAME=\\\"\$PPP_USERNAME\\\"\""
 echo "echo \"PPP_PASSWORD=\\\"\$PPP_PASSWORD\\\"\""
 echo "echo \"PPP_CHATLOGIN=\\\"\$PPP_CHATLOGIN\\\"\""
 echo "echo \"PPP_DEFLATE=\\\"\$PPP_DEFLATE\\\"\""
 echo "echo \"PPP_BSDCOMP=\\\"\$PPP_BSDCOMP\\\"\""
 echo "echo \"PPP_STATICIP=\\\"\$PPP_STATICIP\\\"\""
 echo ") > \"/etc/ppp/$ISP.env\""

) > /tmp/coyote.rebuild

. /tmp/coyote.rebuild
rm -f /tmp/coyote.rebuild

echo "<p>Parameters have been changed, and your default connection has been"
echo "set to '$ISP'</p>"

if [ -n "`pidof pppd`" ]; then
  echo "<p>PPP is running, meaning that you will need to stop and restart it for the changes to take effect.</p>"
fi

touch /etc/coyote/coyote.conf.dirty


echo "<ul><li><a href=\"/cgi-bin/ppp-config-menu.cgi\">PPP and ISP settings</a><br><br>" 
echo "<li><a href=\"/\">Main menu</a></ul>"
