#!/bin/sh

. /etc/coyote/coyote.conf

getval () {
  VAL=`echo $QUERY_STRING | sed "s/.*$PARAM=\([^&]*\)\(&.*\|$\)/\1/"`
  for EXP in "y/+/ /" ":s;/%26/s//\&/;t s" ":s;/%3D/s//\=/;t s" \
             ":s;/%2F/s//\//;t s" ":s;/%3A/s//\:/;t s" ; do
    VAL=`echo $VAL | sed -e "$EXP"` 
  done 
}

getcheck () {
  PARAM="$PARAM1"
  getval
  if [ "$VAL" = "on" ]; then 
    VAL="YES"
  else
    VAL="NO"
  fi
}

getcheckval () {
  PARAM="$PARAM1"
  getval
  if [ "$VAL" = "on" ]; then
    PARAM="$PARAM2"
    getval
    VAL="$VAL"
  else
    VAL="NO"
  fi
}

echo "<h2>Changed Global Connection Settings</h2>"

if [ -z "$QUERY_STRING" ]; then
  echo "<p>Malformed request</p><ul><li><a href=\"/\">Main menu</a></ul>"
  exit
fi

(
  echo ". /etc/coyote/coyote.conf"
  echo "rm -f /etc/coyote/coyote.conf" 

  for PAIR in "minit,PPP_INITSTR" "mtty,PPP_MODEMTTY" "mspd,PPP_PORTSPEED" \
              "hp,WEBCTL_USER_HOMEPAGE" ; do
    PARAM=`echo $PAIR | sed "s/\([^,]*\).*/\1/"`
    getval
    echo "`echo $PAIR | sed "s/[^,]*,\(.*\)/\1/"`=\"$VAL\""
  done

  PARAM1="midle";PARAM2="midlesecs";getcheckval;echo "PPP_IDLE=\"$VAL\""

  PARAM1="mdond";getcheck;echo "PPP_DEMANDDIAL=\"$VAL\""
  PARAM1="autostart";getcheck;echo "PPP_AUTOSTART=\"$VAL\""

 echo "(" 
 cat /etc/coyote/coyote.conf | sed "s/\([^=]*\).*/echo \"\1=\\\\\"$\1\\\\\"\"/" 
 echo ") > /etc/coyote/coyote.conf" 

) > /tmp/coyote.rebuild

. /tmp/coyote.rebuild
rm -f /tmp/coyote.rebuild

echo "<p>Parameters have been changed.</p>"
 
if [ "$PPP_AUTOSTART" = "YES" ]; then
  echo "<p>Auto start of PPP has been enabled, and will call the default ISP"
  echo "at bootup.  The default ISP is currently '$PPP_ISP'</P>"
fi

if [ -n "`pidof pppd`" ]; then
  echo "<p><i>NOTE: PPP is running, meaning that you will need to stop and restart it for the changes to take effect.</i></p>"
fi

touch /etc/coyote/coyote.conf.dirty

echo "<ul><li><a href=\"/cgi-bin/ppp-config-menu.cgi\">PPP and ISP settings</a><br><br>"
echo "<li><a href=\"/\">Main menu</a></ul>"
