#!/bin/sh

echo "<h2>Stop PPP</h2>"

conntime() {
  LASTPPP=`grep pppd /var/log/daemon.log | tail -n 1 | sed "s/.* pppd\[\([0-9]*\)\]: .*/\1/"`
   
  CT=`grep " pppd[$LASTPPP]: Connect time " /var/log/daemon.log | sed "s/^.*Connect time \(.*$\)/\1/"`

  if [ -z "$CT" ]; then
    CT="0 minutes."
  fi
  
  echo "<p>PPPD has been verified to be stopped. "
  echo "You were connected for $CT</p>"
  echo "<ul><li><a href=\"/\">Main menu</a></ul>"

}

# Test that it is running
if [ -z "`pidof pppd`" ]; then

  echo "<p>PPPD is not running.</p>"
  echo "<ul><li><a href=\"/\">Main menu</a></ul>"

  exit

fi 


# Kill nicely
kill -15 `pidof pppd` 2> /dev/null
echo "<p>PPPD has been sent the termination signal.</p>"

for N in 1 2 3 4 5 ; do

  if [ -z "`pidof pppd`" ]; then  
    conntime
    exit
  fi;
  
  sleep 3

done

echo "<p>PPPD has not terminated after 15 seconds.  Attempting to kill instead.</p>" 

while [ -z "" ]; do

  kill -9 `pidof pppd` 2> /dev/null
  echo "<p>PPPD has been sent the kill signal.</p>"
  sleep 5

  if [ -z "`pidof pppd`" ]; then
    conntime
    exit
  fi;

done


 
