/* encoder.c
 *
 * Simple encoder that generates a C string from some file.
 *   Copyright (C) 2001 Michael McTernan
 *                      Michael.McTernan.2001@cs.bris.ac.uk
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */

#include <sys/types.h>
#include <sys/stat.h>
#include <unistd.h>
#include <fcntl.h>
#include <stdlib.h>
#include <stdio.h>

static void usage();

int main(int argC,char *argV[]) {
  int  fd,l;
  long size;  
  char c;

  if(argC>2)
    usage();

  if(argC==2) {
    fd=open(argV[1],O_RDONLY);
    if(fd<=0) {
      printf("%s: Failed to open input file",argV[0]);
      exit(0);
    }
  } else {
    fd=0;  /* Stdin */
  }

  l=0;
  size=0;

  printf("const char data[]={\n");
  while(read(fd,&c,sizeof(char))==sizeof(char)) {
    size+=1;
    printf("% 4d, ",c);
    l+=6;
    if(l>70) {
      printf("\n");
      l=0;
    }
  }

  printf("% 4d\n};\n",0);
  printf("const long size=%ld;\n",size);


  return 0;
}


/*usage*/
/* Print usage info and exit.
 */
static void usage() {

  exit(0);
}


